import moment from 'moment'
// chart data example
var chartData = [
  {'date': '2020-03-01', 'count': 14},
  {'date': '2020-03-02', 'count': 0},
  {'date': '2020-03-03', 'count': 0},
  {'date': '2020-03-04', 'count': 4},
  {'date': '2020-03-05', 'count': 0},
  {'date': '2020-03-06', 'count': 0},
  {'date': '2020-03-07', 'count': 10},
  {'date': '2020-03-08', 'count': 14},
  {'date': '2020-03-09', 'count': 4},
  {'date': '2020-03-10', 'count': 0},
  {'date': '2020-03-11', 'count': 0},
  {'date': '2020-03-12', 'count': 0},
  {'date': '2020-03-13', 'count': 0},
  {'date': '2020-03-14', 'count': 10},
  {'date': '2020-03-15', 'count': 14},
  {'date': '2020-03-16', 'count': 0},
  {'date': '2020-03-17', 'count': 0},
  {'date': '2020-03-18', 'count': 4},
  {'date': '2020-03-19', 'count': 0},
  {'date': '2020-03-20', 'count': 0},
  {'date': '2020-03-21', 'count': 10},
  {'date': '2020-03-22', 'count': 14},
  {'date': '2020-03-23', 'count': 4},
  {'date': '2020-03-24', 'count': 0},
  {'date': '2020-03-25', 'count': 0},
  {'date': '2020-03-26', 'count': 0},
  {'date': '2020-03-27', 'count': 0},
  {'date': '2020-03-28', 'count': 10},
  {'date': '2020-03-29', 'count': 14},
  {'date': '2020-03-30', 'count': 4},
  {'date': '2020-03-31', 'count': 0},
  {'date': '2020-04-01', 'count': 0},
  {'date': '2020-04-02', 'count': 0},
  {'date': '2020-04-03', 'count': 0},
  {'date': '2020-04-04', 'count': 10},
  {'date': '2020-04-05', 'count': 14},
  {'date': '2020-04-06', 'count': 0},
  {'date': '2020-04-07', 'count': 0},
  {'date': '2020-04-08', 'count': 4},
  {'date': '2020-04-09', 'count': 0},
  {'date': '2020-04-10', 'count': 0},
  {'date': '2020-04-11', 'count': 10},
  {'date': '2020-04-12', 'count': 14},
  {'date': '2020-04-13', 'count': 4},
  {'date': '2020-04-14', 'count': 0},
  {'date': '2020-04-15', 'count': 0},
  {'date': '2020-04-16', 'count': 0},
  {'date': '2020-04-17', 'count': 0},
  {'date': '2020-04-18', 'count': 10},
  {'date': '2020-04-19', 'count': 14},
  {'date': '2020-04-20', 'count': 0},
  {'date': '2020-04-21', 'count': 0},
  {'date': '2020-04-22', 'count': 4},
  {'date': '2020-04-23', 'count': 0},
  {'date': '2020-04-24', 'count': 0},
  {'date': '2020-04-25', 'count': 10},
  {'date': '2020-04-26', 'count': 14},
  {'date': '2020-04-27', 'count': 4},
  {'date': '2020-04-28', 'count': 0},
  {'date': '2020-04-29', 'count': 0},
  {'date': '2020-04-30', 'count': 0},
  {'date': '2020-05-01', 'count': 0},
  {'date': '2020-05-02', 'count': 10},
  {'date': '2020-05-03', 'count': 14},
  {'date': '2020-05-04', 'count': 4},
  {'date': '2020-05-05', 'count': 0},
  {'date': '2020-05-06', 'count': 0},
  {'date': '2020-05-07', 'count': 0},
  {'date': '2020-05-08', 'count': 0},
  {'date': '2020-05-09', 'count': 10},
  {'date': '2020-05-10', 'count': 14},
  {'date': '2020-05-11', 'count': 4},
  {'date': '2020-05-12', 'count': 0},
  {'date': '2020-05-13', 'count': 0},
  {'date': '2020-05-14', 'count': 0},
  {'date': '2020-05-15', 'count': 0},
  {'date': '2020-05-16', 'count': 10},
  {'date': '2020-05-17', 'count': 14},
  {'date': '2020-05-18', 'count': 4},
  {'date': '2020-05-19', 'count': 0},
  {'date': '2020-05-20', 'count': 0},
  {'date': '2020-05-21', 'count': 0},
  {'date': '2020-05-22', 'count': 0},
  {'date': '2020-05-23', 'count': 10},
  {'date': '2020-05-24', 'count': 14},
  {'date': '2020-05-25', 'count': 0},
  {'date': '2020-05-26', 'count': 4},
  {'date': '2020-05-27', 'count': 0},
  {'date': '2020-05-28', 'count': 0},
  {'date': '2020-05-29', 'count': 0},
  {'date': '2020-05-30', 'count': 10},
  {'date': '2020-05-31', 'count': 14},
  {'date': '2020-06-01', 'count': 4},
  {'date': '2020-06-02', 'count': 0},
  {'date': '2020-06-03', 'count': 0},
  {'date': '2020-06-04', 'count': 0},
  {'date': '2020-06-05', 'count': 0},
  {'date': '2020-06-06', 'count': 10},
  {'date': '2020-06-07', 'count': 14},
  {'date': '2020-06-08', 'count': 0},
  {'date': '2020-06-09', 'count': 0},
  {'date': '2020-06-10', 'count': 4},
  {'date': '2020-06-11', 'count': 0},
  {'date': '2020-06-12', 'count': 0},
  {'date': '2020-06-13', 'count': 10},
  {'date': '2020-06-14', 'count': 14},
  {'date': '2020-06-15', 'count': 0},
  {'date': '2020-06-16', 'count': 4},
  {'date': '2020-06-17', 'count': 0},
  {'date': '2020-06-18', 'count': 0},
  {'date': '2020-06-19', 'count': 0},
  {'date': '2020-06-20', 'count': 10},
  {'date': '2020-06-21', 'count': 14},
  {'date': '2020-06-22', 'count': 4},
  {'date': '2020-06-23', 'count': 0},
  {'date': '2020-06-24', 'count': 0},
  {'date': '2020-06-25', 'count': 0},
  {'date': '2020-06-26', 'count': 0},
  {'date': '2020-06-27', 'count': 10},
  {'date': '2020-06-28', 'count': 14},
  {'date': '2020-06-29', 'count': 0},
  {'date': '2020-06-30', 'count': 4},
  {'date': '2020-07-01', 'count': 0},
  {'date': '2020-07-02', 'count': 0},
  {'date': '2020-07-03', 'count': 0},
  {'date': '2020-07-04', 'count': 10},
  {'date': '2020-07-05', 'count': 14},
  {'date': '2020-07-06', 'count': 0},
  {'date': '2020-07-07', 'count': 0},
  {'date': '2020-07-08', 'count': 4},
  {'date': '2020-07-09', 'count': 0},
  {'date': '2020-07-10', 'count': 0},
  {'date': '2020-07-11', 'count': 10},
  {'date': '2020-07-12', 'count': 14},
  {'date': '2020-07-13', 'count': 0},
  {'date': '2020-07-14', 'count': 0},
  {'date': '2020-07-15', 'count': 0},
  {'date': '2020-07-16', 'count': 4},
  {'date': '2020-07-17', 'count': 0},
  {'date': '2020-07-18', 'count': 10},
  {'date': '2020-07-19', 'count': 14},
  {'date': '2020-07-20', 'count': 0},
  {'date': '2020-07-21', 'count': 0},
  {'date': '2020-07-22', 'count': 4},
  {'date': '2020-07-23', 'count': 0},
  {'date': '2020-07-24', 'count': 0},
  {'date': '2020-07-25', 'count': 10},
  {'date': '2020-07-26', 'count': 14},
  {'date': '2020-07-27', 'count': 0},
  {'date': '2020-07-28', 'count': 0},
  {'date': '2020-07-29', 'count': 0},
  {'date': '2020-07-30', 'count': 4},
  {'date': '2020-07-31', 'count': 0},
  {'date': '2020-08-01', 'count': 10},
  {'date': '2020-08-02', 'count': 14},
  {'date': '2020-08-03', 'count': 0},
  {'date': '2020-08-04', 'count': 0},
  {'date': '2020-08-05', 'count': 0},
  {'date': '2020-08-06', 'count': 0},
  {'date': '2020-08-07', 'count': 4},
  {'date': '2020-08-08', 'count': 10},
  {'date': '2020-08-09', 'count': 14},
  {'date': '2020-08-10', 'count': 4},
  {'date': '2020-08-11', 'count': 0},
  {'date': '2020-08-12', 'count': 0},
  {'date': '2020-08-13', 'count': 0},
  {'date': '2020-08-14', 'count': 0},
  {'date': '2020-08-15', 'count': 10},
  {'date': '2020-08-16', 'count': 14},
  {'date': '2020-08-17', 'count': 0},
  {'date': '2020-08-18', 'count': 4},
  {'date': '2020-08-19', 'count': 0},
  {'date': '2020-08-20', 'count': 0},
  {'date': '2020-08-21', 'count': 0},
  {'date': '2020-08-22', 'count': 10},
  {'date': '2020-08-23', 'count': 14},
  {'date': '2020-08-24', 'count': 0},
  {'date': '2020-08-25', 'count': 4},
  {'date': '2020-08-26', 'count': 0},
  {'date': '2020-08-27', 'count': 0},
  {'date': '2020-08-28', 'count': 0},
  {'date': '2020-08-29', 'count': 10},
  {'date': '2020-08-30', 'count': 14},
  {'date': '2020-08-31', 'count': 0},
  {'date': '2020-09-01', 'count': 4},
  {'date': '2020-09-02', 'count': 0},
  {'date': '2020-09-03', 'count': 0},
  {'date': '2020-09-04', 'count': 0},
  {'date': '2020-09-05', 'count': 10},
  {'date': '2020-09-06', 'count': 14},
  {'date': '2020-09-07', 'count': 0},
  {'date': '2020-09-08', 'count': 4},
  {'date': '2020-09-09', 'count': 0},
  {'date': '2020-09-10', 'count': 0},
  {'date': '2020-09-11', 'count': 0},
  {'date': '2020-09-12', 'count': 10},
  {'date': '2020-09-13', 'count': 14},
  {'date': '2020-09-14', 'count': 0},
  {'date': '2020-09-15', 'count': 4},
  {'date': '2020-09-16', 'count': 0},
  {'date': '2020-09-17', 'count': 0},
  {'date': '2020-09-18', 'count': 0},
  {'date': '2020-09-19', 'count': 10},
  {'date': '2020-09-20', 'count': 14},
  {'date': '2020-09-21', 'count': 0},
  {'date': '2020-09-22', 'count': 0},
  {'date': '2020-09-23', 'count': 0},
  {'date': '2020-09-24', 'count': 4},
  {'date': '2020-09-25', 'count': 0},
  {'date': '2020-09-26', 'count': 10},
  {'date': '2020-09-27', 'count': 14},
  {'date': '2020-09-28', 'count': 0},
  {'date': '2020-09-29', 'count': 4},
  {'date': '2020-09-30', 'count': 0},
  {'date': '2020-10-01', 'count': 0},
  {'date': '2020-10-02', 'count': 0},
  {'date': '2020-10-03', 'count': 10},
  {'date': '2020-10-04', 'count': 14},
  {'date': '2020-10-05', 'count': 0},
  {'date': '2020-10-06', 'count': 4},
  {'date': '2020-10-07', 'count': 0},
  {'date': '2020-10-08', 'count': 0},
  {'date': '2020-10-09', 'count': 0},
  {'date': '2020-10-10', 'count': 10},
  {'date': '2020-10-11', 'count': 14},
  {'date': '2020-10-12', 'count': 0},
  {'date': '2020-10-13', 'count': 0},
  {'date': '2020-10-14', 'count': 0},
  {'date': '2020-10-15', 'count': 4},
  {'date': '2020-10-16', 'count': 0},
  {'date': '2020-10-17', 'count': 10},
  {'date': '2020-10-18', 'count': 14},
  {'date': '2020-10-19', 'count': 4},
  {'date': '2020-10-20', 'count': 0},
  {'date': '2020-10-21', 'count': 0},
  {'date': '2020-10-22', 'count': 0},
  {'date': '2020-10-23', 'count': 0},
  {'date': '2020-10-24', 'count': 10},
  {'date': '2020-10-25', 'count': 14},
  {'date': '2020-10-26', 'count': 0},
  {'date': '2020-10-27', 'count': 4},
  {'date': '2020-10-28', 'count': 0},
  {'date': '2020-10-29', 'count': 0},
  {'date': '2020-10-30', 'count': 0},
  {'date': '2020-10-31', 'count': 10},
  {'date': '2020-11-01', 'count': 14},
  {'date': '2020-11-02', 'count': 4},
  {'date': '2020-11-03', 'count': 0},
  {'date': '2020-11-04', 'count': 0},
  {'date': '2020-11-05', 'count': 0}
];
var chart1 = calendarHeatmap()
              .data(chartData)
              .selector('#chart-one')
              .colorRange(['#D8E6E7', '#218380'])
              .tooltipEnabled(true)
              .onClick(function (data) {
                console.log('onClick callback. Data:', data);
              });
chart1();  // render the chart


function calendarHeatmap() {
  // defaults
  var width = 750;
  var height = 110;
  var legendWidth = 150;
  var selector = 'body';
  var SQUARE_LENGTH = 11;
  var SQUARE_PADDING = 2;
  var MONTH_LABEL_PADDING = 6;
  var now = moment().endOf('day').toDate();
  var yearAgo = moment().startOf('day').subtract(1, 'year').toDate();
  var startDate = null;
  var counterMap= {};
  var data = [];
  var max = null;
  var colorRange = ['#D8E6E7', '#218380'];
  var tooltipEnabled = true;
  var tooltipUnit = 'contribution';
  var legendEnabled = true;
  var onClick = null;
  var weekStart = 0; //0 for Sunday, 1 for Monday
  var locale = {
    months: ['Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'],
    days: ['S', 'M', 'T', 'W', 'T', 'F', 'S'],
    No: 'No',
    on: 'on',
    Less: 'Less',
    More: 'More'
  };
  var v = Number(d3.version.split('.')[0]);

  // setters and getters
  chart.data = function (value) {
    if (!arguments.length) { return data; }
    data = value;

    counterMap= {};

    data.forEach(function (element, index) {
        var key= moment(element.date).format( 'YYYY-MM-DD' );
        var counter= counterMap[key] || 0;
        counterMap[key]= counter + element.count;
    });

    return chart;
  };

  chart.max = function (value) {
    if (!arguments.length) { return max; }
    max = value;
    return chart;
  };

  chart.selector = function (value) {
    if (!arguments.length) { return selector; }
    selector = value;
    return chart;
  };

  chart.startDate = function (value) {
    if (!arguments.length) { return startDate; }
    yearAgo = value;
    now = moment(value).endOf('day').add(1, 'year').toDate();
    return chart;
  };

  chart.colorRange = function (value) {
    if (!arguments.length) { return colorRange; }
    colorRange = value;
    return chart;
  };

  chart.tooltipEnabled = function (value) {
    if (!arguments.length) { return tooltipEnabled; }
    tooltipEnabled = value;
    return chart;
  };

  chart.tooltipUnit = function (value) {
    if (!arguments.length) { return tooltipUnit; }
    tooltipUnit = value;
    return chart;
  };

  chart.legendEnabled = function (value) {
    if (!arguments.length) { return legendEnabled; }
    legendEnabled = value;
    return chart;
  };

  chart.onClick = function (value) {
    if (!arguments.length) { return onClick(); }
    onClick = value;
    return chart;
  };

  chart.locale = function (value) {
    if (!arguments.length) { return locale; }
    locale = value;
    return chart;
  };

  function chart() {

    d3.select(chart.selector()).selectAll('svg.calendar-heatmap').remove(); // remove the existing chart, if it exists

    var dateRange = ((d3.time && d3.time.days) || d3.timeDays)(yearAgo, now); // generates an array of date objects within the specified range
    var monthRange = ((d3.time && d3.time.months) || d3.timeMonths)(moment(yearAgo).startOf('month').toDate(), now); // it ignores the first month if the 1st date is after the start of the month
    var firstDate = moment(dateRange[0]);
    if (chart.data().length == 0) {
      max = 0;
    } else if (max === null) {
      max = d3.max(chart.data(), function (d) { return d.count; }); // max data value
    }

    // color range
    var color = ((d3.scale && d3.scale.linear) || d3.scaleLinear)()
      .range(chart.colorRange())
      .domain([0, max]);

    var tooltip;
    var dayRects;

    drawChart();

    function drawChart() {
      var svg = d3.select(chart.selector())
        .style('position', 'relative')
        .append('svg')
        .attr('width', width)
        .attr('class', 'calendar-heatmap')
        .attr('height', height)
        .style('padding', '36px');

      dayRects = svg.selectAll('.day-cell')
        .data(dateRange);  //  array of days for the last yr

      var enterSelection = dayRects.enter().append('rect')
        .attr('class', 'day-cell')
        .attr('width', SQUARE_LENGTH)
        .attr('height', SQUARE_LENGTH)
        .attr('fill', function(d) { return color(countForDate(d)); })
        .attr('x', function (d, i) {
          var cellDate = moment(d);
          var result = cellDate.week() - firstDate.week() + (firstDate.weeksInYear() * (cellDate.weekYear() - firstDate.weekYear()));
          return result * (SQUARE_LENGTH + SQUARE_PADDING);
        })
        .attr('y', function (d, i) {
          return MONTH_LABEL_PADDING + formatWeekday(d.getDay()) * (SQUARE_LENGTH + SQUARE_PADDING);
        });

      if (typeof onClick === 'function') {
        (v === 3 ? enterSelection : enterSelection.merge(dayRects)).on('click', function(d) {
          var count = countForDate(d);
          onClick({ date: d, count: count});
        });
      }

      if (chart.tooltipEnabled()) {
        (v === 3 ? enterSelection : enterSelection.merge(dayRects)).on('mouseover', function(d, i) {
          tooltip = d3.select(chart.selector())
            .append('div')
            .attr('class', 'day-cell-tooltip')
            .html(tooltipHTMLForDate(d))
            .style('left', function () { return Math.floor(i / 7) * SQUARE_LENGTH + 'px'; })
            .style('top', function () {
              return formatWeekday(d.getDay()) * (SQUARE_LENGTH + SQUARE_PADDING) + MONTH_LABEL_PADDING * 2 + 'px';
            });
        })
        .on('mouseout', function (d, i) {
          tooltip.remove();
        });
      }

      if (chart.legendEnabled()) {
        var colorRange = [color(0)];
        for (var i = 3; i > 0; i--) {
          colorRange.push(color(max / i));
        }

        var legendGroup = svg.append('g');
        legendGroup.selectAll('.calendar-heatmap-legend')
            .data(colorRange)
            .enter()
          .append('rect')
            .attr('class', 'calendar-heatmap-legend')
            .attr('width', SQUARE_LENGTH)
            .attr('height', SQUARE_LENGTH)
            .attr('x', function (d, i) { return (width - legendWidth) + (i + 1) * 13; })
            .attr('y', height + SQUARE_PADDING)
            .attr('fill', function (d) { return d; });

        legendGroup.append('text')
          .attr('class', 'calendar-heatmap-legend-text calendar-heatmap-legend-text-less')
          .attr('x', width - legendWidth - 13)
          .attr('y', height + SQUARE_LENGTH)
          .text(locale.Less);

        legendGroup.append('text')
          .attr('class', 'calendar-heatmap-legend-text calendar-heatmap-legend-text-more')
          .attr('x', (width - legendWidth + SQUARE_PADDING) + (colorRange.length + 1) * 13)
          .attr('y', height + SQUARE_LENGTH)
          .text(locale.More);
      }

      dayRects.exit().remove();
      var monthLabels = svg.selectAll('.month')
          .data(monthRange)
          .enter().append('text')
          .attr('class', 'month-name')
          .text(function (d) {
            return locale.months[d.getMonth()];
          })
          .attr('x', function (d, i) {
            var matchIndex = 0;
            dateRange.find(function (element, index) {
              matchIndex = index;
              return moment(d).isSame(element, 'month') && moment(d).isSame(element, 'year');
            });

            return Math.floor(matchIndex / 7) * (SQUARE_LENGTH + SQUARE_PADDING);
          })
          .attr('y', 0);  // fix these to the top

      locale.days.forEach(function (day, index) {
        index = formatWeekday(index);
        if (index % 2) {
          svg.append('text')
            .attr('class', 'day-initial')
            .attr('transform', 'translate(-8,' + (SQUARE_LENGTH + SQUARE_PADDING) * (index + 1) + ')')
            .style('text-anchor', 'middle')
            .attr('dy', '2')
            .text(day);
        }
      });
    }

    function pluralizedTooltipUnit (count) {
      if ('string' === typeof tooltipUnit) {
        return (tooltipUnit + (count === 1 ? '' : 's'));
      }
      for (var i in tooltipUnit) {
        var _rule = tooltipUnit[i];
        var _min = _rule.min;
        var _max = _rule.max || _rule.min;
        _max = _max === 'Infinity' ? Infinity : _max;
        if (count >= _min && count <= _max) {
          return _rule.unit;
        }
      }
    }

    function tooltipHTMLForDate(d) {
      var dateStr = moment(d).format('ddd, MMM Do YYYY');
      var count = countForDate(d);
      return '<span><strong>' + (count ? count : locale.No) + ' ' + pluralizedTooltipUnit(count) + '</strong> ' + locale.on + ' ' + dateStr + '</span>';
    }

    function countForDate(d) {
        var key= moment(d).format( 'YYYY-MM-DD' );
        return counterMap[key] || 0;
    }

    function formatWeekday(weekDay) {
      if (weekStart === 1) {
        if (weekDay === 0) {
          return 6;
        } else {
          return weekDay - 1;
        }
      }
      return weekDay;
    }

    // var daysOfChart = chart.data().map(function (day) {
    //   return day.date.toDateString();
    // });

  }

  return chart;
}


// polyfill for Array.find() method
/* jshint ignore:start */
if (!Array.prototype.find) {
  Array.prototype.find = function (predicate) {
    if (this === null) {
      throw new TypeError('Array.prototype.find called on null or undefined');
    }
    if (typeof predicate !== 'function') {
      throw new TypeError('predicate must be a function');
    }
    var list = Object(this);
    var length = list.length >>> 0;
    var thisArg = arguments[1];
    var value;

    for (var i = 0; i < length; i++) {
      value = list[i];
      if (predicate.call(thisArg, value, i, list)) {
        return value;
      }
    }
    return undefined;
  };
}
/* jshint ignore:end */